GNU bug report logs - #20640
24.5; lexical-binding should work like a normal file-local variable

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: wishlist; Reported by: Philipp Stephani <p.stephani2@HIDDEN>; Keywords: wontfix; merged with #10605, #15849; dated Sun, 24 May 2015 10:21:03 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 20640 <at> debbugs.gnu.org:


Received: (at 20640) by debbugs.gnu.org; 22 Jun 2015 15:57:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 22 11:57:32 2015
Received: from localhost ([127.0.0.1]:54659 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Z746F-0004gA-IR
	for submit <at> debbugs.gnu.org; Mon, 22 Jun 2015 11:57:31 -0400
Received: from mercure.iro.umontreal.ca ([132.204.24.67]:34659)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <monnier@HIDDEN>) id 1Z746E-0004g3-JJ
 for 20640 <at> debbugs.gnu.org; Mon, 22 Jun 2015 11:57:30 -0400
Received: from hidalgo.iro.umontreal.ca (hidalgo.iro.umontreal.ca
 [132.204.27.50])
 by mercure.iro.umontreal.ca (Postfix) with ESMTP id 9DFE19C172;
 Mon, 22 Jun 2015 11:57:28 -0400 (EDT)
Received: from lechon.iro.umontreal.ca (lechon.iro.umontreal.ca
 [132.204.27.242])
 by hidalgo.iro.umontreal.ca (Postfix) with ESMTP id C33F31E5B8D;
 Mon, 22 Jun 2015 11:57:03 -0400 (EDT)
Received: by lechon.iro.umontreal.ca (Postfix, from userid 20848)
 id 3E048B4086; Mon, 22 Jun 2015 11:56:46 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Philipp Stephani <p.stephani2@HIDDEN>
Subject: Re: bug#20640: 24.5;
 lexical-binding should work like a normal file-local variable
Message-ID: <jwvoak7rb35.fsf-monnier+emacsbugs@HIDDEN>
References: <m2a8wu5lc9.fsf@HIDDEN>
 <jwvr3q5to61.fsf-monnier+emacsbugs@HIDDEN>
 <55638701.9010400@HIDDEN>
 <jwvtwv0b73f.fsf-monnier+emacsbugs@HIDDEN>
 <tn7frwp2oo.fsf@HIDDEN>
 <jwvlhgbe031.fsf-monnier+emacsbugs@HIDDEN>
 <p5wpzvt617.fsf@HIDDEN>
 <jwvvbfeaj79.fsf-monnier+emacsbugs@HIDDEN>
 <CAArVCkSL2zxP=dFkWO37vAf=-oBGK9pKE12uUeGJ7U15GgrO7w@HIDDEN>
Date: Mon, 22 Jun 2015 11:56:46 -0400
In-Reply-To: <CAArVCkSL2zxP=dFkWO37vAf=-oBGK9pKE12uUeGJ7U15GgrO7w@HIDDEN>
 (Philipp Stephani's message of "Sun, 21 Jun 2015 20:08:52 +0000")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-DIRO-MailScanner-Information: Please contact the ISP for more information
X-DIRO-MailScanner: Found to be clean
X-DIRO-MailScanner-SpamCheck: n'est pas un polluriel,
 SpamAssassin (score=-2.82, requis 5, autolearn=not spam,
 ALL_TRUSTED -2.82, MC_TSTLAST 0.00)
X-DIRO-MailScanner-From: monnier@HIDDEN
X-Spam-Status: No
X-Spam-Score: -3.7 (---)
X-Debbugs-Envelope-To: 20640
Cc: Glenn Morris <rgm@HIDDEN>, Daniel Colascione <dancol@HIDDEN>,
 20640 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.7 (---)

> I don't think this is a misdesign. In most cases files are either seekable
> or small enough so that reading the variables from the end is tolerable. I
> prefer the end of files for local variables because they tend to be less
> important than the actual content.

I'm not talking about file-local variables in general.  I'm talking
about the "coding:" pseudo-variable.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#20640; Package emacs. Full text available.

Message received at 20640 <at> debbugs.gnu.org:


Received: (at 20640) by debbugs.gnu.org; 21 Jun 2015 20:09:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jun 21 16:09:12 2015
Received: from localhost ([127.0.0.1]:53626 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Z6lYF-0000kL-Mu
	for submit <at> debbugs.gnu.org; Sun, 21 Jun 2015 16:09:12 -0400
Received: from mail-wi0-f176.google.com ([209.85.212.176]:32832)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <p.stephani2@HIDDEN>) id 1Z6lYC-0000k7-Io
 for 20640 <at> debbugs.gnu.org; Sun, 21 Jun 2015 16:09:09 -0400
Received: by wiwl6 with SMTP id l6so19831583wiw.0
 for <20640 <at> debbugs.gnu.org>; Sun, 21 Jun 2015 13:09:03 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-type;
 bh=zbCEhCBFES9T9Ay1exreHVJqz4faS6VHTtLbwhBOoCc=;
 b=p4lwoe1fHn2gL9iBPTaKX5BITl4SQqTZsndN0kLKBps1sGfrxNw6m2q0JSwHqqpK5R
 I+3p03pIxP61QaYa+5YlGSZEKX+Kk4HtxCVLYUIB5QEP1hpzzzwW6d+9WYHMiCN6lvIN
 ZU2wf+O8Osm3egh5m4lXowk1AcUjmPBNp7keVGs/ehqrAtDNtaWwgk8KFa3HGLVswKWJ
 lEpAkKf87GzQU4lWrpgS4Nh+CAAb5vWdQWlhRSyAFVs3S/x0bIeeyTBwtDgx4HcBYyWl
 9OJESbkgj+yxzyqNdYIGUGMBDMQGgJ8undKXDfWTomFu2vnjuycfo0MvRHNB29+2KTK6
 KwhQ==
X-Received: by 10.194.176.165 with SMTP id cj5mr45646296wjc.72.1434917343065; 
 Sun, 21 Jun 2015 13:09:03 -0700 (PDT)
MIME-Version: 1.0
References: <m2a8wu5lc9.fsf@HIDDEN>
 <jwvr3q5to61.fsf-monnier+emacsbugs@HIDDEN>
 <55638701.9010400@HIDDEN> <jwvtwv0b73f.fsf-monnier+emacsbugs@HIDDEN>
 <tn7frwp2oo.fsf@HIDDEN> <jwvlhgbe031.fsf-monnier+emacsbugs@HIDDEN>
 <p5wpzvt617.fsf@HIDDEN> <jwvvbfeaj79.fsf-monnier+emacsbugs@HIDDEN>
In-Reply-To: <jwvvbfeaj79.fsf-monnier+emacsbugs@HIDDEN>
From: Philipp Stephani <p.stephani2@HIDDEN>
Date: Sun, 21 Jun 2015 20:08:52 +0000
Message-ID: <CAArVCkSL2zxP=dFkWO37vAf=-oBGK9pKE12uUeGJ7U15GgrO7w@HIDDEN>
Subject: Re: bug#20640: 24.5; lexical-binding should work like a normal
 file-local variable
To: Stefan Monnier <monnier@HIDDEN>, Glenn Morris <rgm@HIDDEN>
Content-Type: multipart/alternative; boundary=089e013d15d883fb1405190cba88
X-Spam-Score: -0.4 (/)
X-Debbugs-Envelope-To: 20640
Cc: Daniel Colascione <dancol@HIDDEN>, 20640 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.4 (/)

--089e013d15d883fb1405190cba88
Content-Type: text/plain; charset=UTF-8

Stefan Monnier <monnier@HIDDEN> schrieb am Mi., 27. Mai 2015 um
03:49 Uhr:

> > Even if the code were to check for "coding:" (which we already have to
> > scan the end of the file for) and "lexical-binding:" in the same pass?
>
> The check for "coding:" is a misdesign, indeed.  I think we should use
> some utf-8 tell-tale sign at the beginning of *.el files to eliminate
> the need to check for "coding:" (and to go through
> load-with-code-conversion) in the normal case.  It could be a utf-8 BOM
> or something like that.  Ideally we could give extra meaning to this
> marker so it not only means "uses utf-8" but also "uses
> lexical-scoping", so that we can have a future where we don't need to
> add "lexical-binding:t" to every file.
>
>
>
I don't think this is a misdesign. In most cases files are either seekable
or small enough so that reading the variables from the end is tolerable. I
prefer the end of files for local variables because they tend to be less
important than the actual content.

--089e013d15d883fb1405190cba88
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr"><br><br><div class=3D"gmail_quote"><div dir=3D"ltr">Stefan=
 Monnier &lt;<a href=3D"mailto:monnier@HIDDEN">monnier@HIDDEN=
eal.ca</a>&gt; schrieb am Mi., 27. Mai 2015 um 03:49=C2=A0Uhr:<br></div><bl=
ockquote class=3D"gmail_quote" style=3D"margin:0 0 0 .8ex;border-left:1px #=
ccc solid;padding-left:1ex">&gt; Even if the code were to check for &quot;c=
oding:&quot; (which we already have to<br>
&gt; scan the end of the file for) and &quot;lexical-binding:&quot; in the =
same pass?<br>
<br>
The check for &quot;coding:&quot; is a misdesign, indeed.=C2=A0 I think we =
should use<br>
some utf-8 tell-tale sign at the beginning of *.el files to eliminate<br>
the need to check for &quot;coding:&quot; (and to go through<br>
load-with-code-conversion) in the normal case.=C2=A0 It could be a utf-8 BO=
M<br>
or something like that.=C2=A0 Ideally we could give extra meaning to this<b=
r>
marker so it not only means &quot;uses utf-8&quot; but also &quot;uses<br>
lexical-scoping&quot;, so that we can have a future where we don&#39;t need=
 to<br>
add &quot;lexical-binding:t&quot; to every file.<br>
<br>
<br></blockquote><div><br></div><div>I don&#39;t think this is a misdesign.=
 In most cases files are either seekable or small enough so that reading th=
e variables from the end is tolerable. I prefer the end of files for local =
variables because they tend to be less important than the actual content.=
=C2=A0</div></div></div>

--089e013d15d883fb1405190cba88--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#20640; Package emacs. Full text available.
Added tag(s) wontfix. Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Severity set to 'wishlist' from 'minor' Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 20640 <at> debbugs.gnu.org:


Received: (at 20640) by debbugs.gnu.org; 27 May 2015 01:49:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue May 26 21:49:45 2015
Received: from localhost ([127.0.0.1]:57566 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1YxQTZ-0004Xl-94
	for submit <at> debbugs.gnu.org; Tue, 26 May 2015 21:49:45 -0400
Received: from ironport2-out.teksavvy.com ([206.248.154.181]:12863)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <monnier@HIDDEN>) id 1YxQTW-0004XY-5n
 for 20640 <at> debbugs.gnu.org; Tue, 26 May 2015 21:49:43 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: A0CYDQA731xV/9N+3mhcgxCEAshgBAICgTw8EQEBAQEBAQGBCkEFg10BAQMBViMFCwsOJhIUGA0kiDcIzyMBAQEBBgEBAQEeizqFBQeELQW1BCOBZlWBWSKCeAEBAQ
X-IPAS-Result: A0CYDQA731xV/9N+3mhcgxCEAshgBAICgTw8EQEBAQEBAQGBCkEFg10BAQMBViMFCwsOJhIUGA0kiDcIzyMBAQEBBgEBAQEeizqFBQeELQW1BCOBZlWBWSKCeAEBAQ
X-IronPort-AV: E=Sophos;i="5.13,465,1427774400"; d="scan'208";a="122335509"
Received: from 104-222-126-211.cpe.teksavvy.com (HELO ceviche.home)
 ([104.222.126.211])
 by ironport2-out.teksavvy.com with ESMTP/TLS/DHE-RSA-AES256-SHA;
 26 May 2015 21:49:36 -0400
Received: by ceviche.home (Postfix, from userid 20848)
 id DEC61660ED; Tue, 26 May 2015 21:49:35 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Glenn Morris <rgm@HIDDEN>
Subject: Re: bug#20640: 24.5;
 lexical-binding should work like a normal file-local variable
Message-ID: <jwvvbfeaj79.fsf-monnier+emacsbugs@HIDDEN>
References: <m2a8wu5lc9.fsf@HIDDEN>
 <jwvr3q5to61.fsf-monnier+emacsbugs@HIDDEN>
 <55638701.9010400@HIDDEN>
 <jwvtwv0b73f.fsf-monnier+emacsbugs@HIDDEN>
 <tn7frwp2oo.fsf@HIDDEN>
 <jwvlhgbe031.fsf-monnier+emacsbugs@HIDDEN>
 <p5wpzvt617.fsf@HIDDEN>
Date: Tue, 26 May 2015 21:49:35 -0400
In-Reply-To: <p5wpzvt617.fsf@HIDDEN> (Glenn Morris's message of
 "Tue, 26 May 2015 16:53:08 -0400")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 20640
Cc: Philipp Stephani <p.stephani2@HIDDEN>,
 Daniel Colascione <dancol@HIDDEN>, 20640 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

> Even if the code were to check for "coding:" (which we already have to
> scan the end of the file for) and "lexical-binding:" in the same pass?

The check for "coding:" is a misdesign, indeed.  I think we should use
some utf-8 tell-tale sign at the beginning of *.el files to eliminate
the need to check for "coding:" (and to go through
load-with-code-conversion) in the normal case.  It could be a utf-8 BOM
or something like that.  Ideally we could give extra meaning to this
marker so it not only means "uses utf-8" but also "uses
lexical-scoping", so that we can have a future where we don't need to
add "lexical-binding:t" to every file.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#20640; Package emacs. Full text available.

Message received at 20640 <at> debbugs.gnu.org:


Received: (at 20640) by debbugs.gnu.org; 26 May 2015 20:53:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue May 26 16:53:14 2015
Received: from localhost ([127.0.0.1]:57451 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1YxLqb-0002wa-Bv
	for submit <at> debbugs.gnu.org; Tue, 26 May 2015 16:53:14 -0400
Received: from fencepost.gnu.org ([208.118.235.10]:49988 ident=Debian-exim)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <rgm@HIDDEN>) id 1YxLqY-0002wR-V2
 for 20640 <at> debbugs.gnu.org; Tue, 26 May 2015 16:53:11 -0400
Received: from rgm by fencepost.gnu.org with local (Exim 4.71)
 (envelope-from <rgm@HIDDEN>)
 id 1YxLqX-0007Ym-0m; Tue, 26 May 2015 16:53:09 -0400
From: Glenn Morris <rgm@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#20640: 24.5;
 lexical-binding should work like a normal file-local variable
References: <m2a8wu5lc9.fsf@HIDDEN>
 <jwvr3q5to61.fsf-monnier+emacsbugs@HIDDEN>
 <55638701.9010400@HIDDEN>
 <jwvtwv0b73f.fsf-monnier+emacsbugs@HIDDEN>
 <tn7frwp2oo.fsf@HIDDEN>
 <jwvlhgbe031.fsf-monnier+emacsbugs@HIDDEN>
X-Spook: csim Honduras Capricorn lynch Dateline Rand Corporation
X-Ran: J%4_DjO`7;}Y7::;yxN0ZL*|RNLQ'1R%k[V.e<g/Rjea*,>).ENv.$M0o}9AR|]ziPsMZv
X-Hue: yellow
X-Debbugs-No-Ack: yes
X-Attribution: GM
Date: Tue, 26 May 2015 16:53:08 -0400
Message-ID: <p5wpzvt617.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 20640
Cc: Philipp Stephani <p.stephani2@HIDDEN>,
 Daniel Colascione <dancol@HIDDEN>, 20640 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

Stefan Monnier wrote:

>> A few years ago, we said (IIUC) it was desirable:
>> http://debbugs.gnu.org/10605
>
> Well, *you* said, but *we* didn't, IIUC.

Hah, true enough, although IMO you were a least a little more ambiguous in

>> http://lists.gnu.org/archive/html/emacs-devel/2012-01/msg00543.html


Anyway:

> For me, as long as we intend to allow running .el files without
> byte-compiling them, I think allowing lexical-binding to be specified at
> the end of the file would be a design mistake.

Even if the code were to check for "coding:" (which we already have to
scan the end of the file for) and "lexical-binding:" in the same pass?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#20640; Package emacs. Full text available.

Message received at 20640 <at> debbugs.gnu.org:


Received: (at 20640) by debbugs.gnu.org; 26 May 2015 17:13:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue May 26 13:13:02 2015
Received: from localhost ([127.0.0.1]:57277 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1YxIPV-0005oO-Mp
	for submit <at> debbugs.gnu.org; Tue, 26 May 2015 13:13:02 -0400
Received: from mercure.iro.umontreal.ca ([132.204.24.67]:34540)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <monnier@HIDDEN>) id 1YxIPT-0005oF-2X
 for 20640 <at> debbugs.gnu.org; Tue, 26 May 2015 13:12:59 -0400
Received: from hidalgo.iro.umontreal.ca (hidalgo.iro.umontreal.ca
 [132.204.27.50])
 by mercure.iro.umontreal.ca (Postfix) with ESMTP id 49D9611C044;
 Tue, 26 May 2015 13:12:58 -0400 (EDT)
Received: from lechon.iro.umontreal.ca (lechon.iro.umontreal.ca
 [132.204.27.242])
 by hidalgo.iro.umontreal.ca (Postfix) with ESMTP id 633551E5B94;
 Tue, 26 May 2015 13:12:31 -0400 (EDT)
Received: by lechon.iro.umontreal.ca (Postfix, from userid 20848)
 id 464A1B44A5; Tue, 26 May 2015 13:12:31 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Glenn Morris <rgm@HIDDEN>
Subject: Re: bug#20640: 24.5;
 lexical-binding should work like a normal file-local variable
Message-ID: <jwvlhgbe031.fsf-monnier+emacsbugs@HIDDEN>
References: <m2a8wu5lc9.fsf@HIDDEN>
 <jwvr3q5to61.fsf-monnier+emacsbugs@HIDDEN>
 <55638701.9010400@HIDDEN>
 <jwvtwv0b73f.fsf-monnier+emacsbugs@HIDDEN>
 <tn7frwp2oo.fsf@HIDDEN>
Date: Tue, 26 May 2015 13:12:31 -0400
In-Reply-To: <tn7frwp2oo.fsf@HIDDEN> (Glenn Morris's message of
 "Mon, 25 May 2015 21:06:47 -0400")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-DIRO-MailScanner-Information: Please contact the ISP for more information
X-DIRO-MailScanner: Found to be clean
X-DIRO-MailScanner-SpamCheck: n'est pas un polluriel,
 SpamAssassin (score=-2.82, requis 5, autolearn=not spam,
 ALL_TRUSTED -2.82, MC_TSTLAST 0.00)
X-DIRO-MailScanner-From: monnier@HIDDEN
X-Spam-Status: No
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 20640
Cc: Philipp Stephani <p.stephani2@HIDDEN>,
 Daniel Colascione <dancol@HIDDEN>, 20640 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

> A few years ago, we said (IIUC) it was desirable:
> http://debbugs.gnu.org/10605

Well, *you* said, but *we* didn't, IIUC.

For me, as long as we intend to allow running .el files without
byte-compiling them, I think allowing lexical-binding to be specified at
the end of the file would be a design mistake.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#20640; Package emacs. Full text available.

Message received at 20640 <at> debbugs.gnu.org:


Received: (at 20640) by debbugs.gnu.org; 26 May 2015 01:06:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 25 21:06:53 2015
Received: from localhost ([127.0.0.1]:56016 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Yx3KW-0002Fn-IG
	for submit <at> debbugs.gnu.org; Mon, 25 May 2015 21:06:52 -0400
Received: from fencepost.gnu.org ([208.118.235.10]:59044 ident=Debian-exim)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <rgm@HIDDEN>) id 1Yx3KU-0002Ff-CL
 for 20640 <at> debbugs.gnu.org; Mon, 25 May 2015 21:06:50 -0400
Received: from rgm by fencepost.gnu.org with local (Exim 4.71)
 (envelope-from <rgm@HIDDEN>)
 id 1Yx3KR-0007y6-Kj; Mon, 25 May 2015 21:06:47 -0400
From: Glenn Morris <rgm@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#20640: 24.5;
 lexical-binding should work like a normal file-local variable
References: <m2a8wu5lc9.fsf@HIDDEN>
 <jwvr3q5to61.fsf-monnier+emacsbugs@HIDDEN>
 <55638701.9010400@HIDDEN>
 <jwvtwv0b73f.fsf-monnier+emacsbugs@HIDDEN>
X-Spook: warfare class struggle basement terrorism MD4 beanpole
X-Ran: atpA(qg!~Fa}D|l-D>0nE@y9:+lh-[\Gi8F1gxr\p(ooVt36$vT6Z}AZBoS/,?A<#n=q4E
X-Hue: white
X-Debbugs-No-Ack: yes
X-Attribution: GM
Date: Mon, 25 May 2015 21:06:47 -0400
In-Reply-To: <jwvtwv0b73f.fsf-monnier+emacsbugs@HIDDEN> (Stefan Monnier's
 message of "Mon, 25 May 2015 18:55:50 -0400")
Message-ID: <tn7frwp2oo.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 20640
Cc: Philipp Stephani <p.stephani2@HIDDEN>,
 Daniel Colascione <dancol@HIDDEN>, 20640 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

Stefan Monnier wrote:

>>> Allowing it at the end of the file, would require jumping to the end of
>>> the file first, and then starting over from the beginning.
>>> That'd be a very bad requirement.
>> Why? We're going to have to read that page eventually anyway.
>
> Because we can't read the first page correctly until we know whether it
> should be read in lexical-binding mode or in dynamic-binding mode.

A few years ago, we said (IIUC) it was desirable:

http://debbugs.gnu.org/10605
http://lists.gnu.org/archive/html/emacs-devel/2012-01/msg00543.html

Or have speed-ups in uncompiled code shifted the balance?

(But no-one shows any sign of doing anything, so it's all academic.)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#20640; Package emacs. Full text available.

Message received at 20640 <at> debbugs.gnu.org:


Received: (at 20640) by debbugs.gnu.org; 25 May 2015 22:55:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 25 18:55:59 2015
Received: from localhost ([127.0.0.1]:55956 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Yx1Hq-0007io-KX
	for submit <at> debbugs.gnu.org; Mon, 25 May 2015 18:55:59 -0400
Received: from ironport2-out.teksavvy.com ([206.248.154.181]:7813)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <monnier@HIDDEN>) id 1Yx1Ho-0007iZ-Jf
 for 20640 <at> debbugs.gnu.org; Mon, 25 May 2015 18:55:56 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: A0AsEwA731xV/9N+3mhcgxCEAoVVuzcJh0sEAgKBPDkUAQEBAQEBAYEKQQWDXQEBAwFWIxALDiYSFBgNJIg3CM8jAQEBAQYBAQEBHos6hQUHhC0FnxeGaY8EI4I7gVkigngBAQE
X-IPAS-Result: A0AsEwA731xV/9N+3mhcgxCEAoVVuzcJh0sEAgKBPDkUAQEBAQEBAYEKQQWDXQEBAwFWIxALDiYSFBgNJIg3CM8jAQEBAQYBAQEBHos6hQUHhC0FnxeGaY8EI4I7gVkigngBAQE
X-IronPort-AV: E=Sophos;i="5.13,465,1427774400"; d="scan'208";a="122193391"
Received: from 104-222-126-211.cpe.teksavvy.com (HELO ceviche.home)
 ([104.222.126.211])
 by ironport2-out.teksavvy.com with ESMTP/TLS/DHE-RSA-AES256-SHA;
 25 May 2015 18:55:51 -0400
Received: by ceviche.home (Postfix, from userid 20848)
 id CA292660EF; Mon, 25 May 2015 18:55:50 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Daniel Colascione <dancol@HIDDEN>
Subject: Re: bug#20640: 24.5;
 lexical-binding should work like a normal file-local variable
Message-ID: <jwvtwv0b73f.fsf-monnier+emacsbugs@HIDDEN>
References: <m2a8wu5lc9.fsf@HIDDEN>
 <jwvr3q5to61.fsf-monnier+emacsbugs@HIDDEN>
 <55638701.9010400@HIDDEN>
Date: Mon, 25 May 2015 18:55:50 -0400
In-Reply-To: <55638701.9010400@HIDDEN> (Daniel Colascione's message of
 "Mon, 25 May 2015 13:33:05 -0700")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 20640
Cc: Philipp Stephani <p.stephani2@HIDDEN>, 20640 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

>>> I think the only reason for this is an implementation detail
>>> (lexical-binding is parsed by other code than the other file-local
>>> variables).  It would be great to make it consistent with other
>>> variables so that the user doesn't need to care about the difference.
>> Allowing it at the end of the file, would require jumping to the end of
>> the file first, and then starting over from the beginning.
>> That'd be a very bad requirement.
> Why? We're going to have to read that page eventually anyway.

Because we can't read the first page correctly until we know whether it
should be read in lexical-binding mode or in dynamic-binding mode.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#20640; Package emacs. Full text available.

Message received at 20640 <at> debbugs.gnu.org:


Received: (at 20640) by debbugs.gnu.org; 25 May 2015 20:33:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 25 16:33:13 2015
Received: from localhost ([127.0.0.1]:55896 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ywz3h-0004Q1-1D
	for submit <at> debbugs.gnu.org; Mon, 25 May 2015 16:33:13 -0400
Received: from dancol.org ([96.126.100.184]:49778)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <dancol@HIDDEN>) id 1Ywz3f-0004Pt-1V
 for 20640 <at> debbugs.gnu.org; Mon, 25 May 2015 16:33:11 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=dancol.org;
 s=x; 
 h=Content-Type:In-Reply-To:References:Subject:CC:To:MIME-Version:From:Date:Message-ID;
 bh=MD4rzEF8F9gCUYzdM/RABIfphr1Ys08ltIfyx7TrLsc=; 
 b=JaAJCGw+UlelJDN3xTTvsxu1MXuMOvbAA667vBaLDGXoVoOIM0Uf6+lJ/KuXPeoSNzCwWXKg3NtIjdr1eqs/WNyuCVclGweLyCPp/CdLb1U1+hz7Q7FHdtz0ABSOH09b+8KwL5O2kb590UfexYVoyyqXh0RQoNwhoW/xVYkReoTeEJtpxUnkFtnRC0cxF4OmHRLVycmPAEyUx5ay+sn8QDptKbvlfLZvSUJU4MOQmCBevkDZeCn3+EeElzloX58dlFgitVgSTlfWQMx9yzw6DZarawgR+TzRn+XEiFD5Gt8vvwFetDOPiHveppB5CGgOL2md16DLTV/n3QF7A2ftVw==;
Received: from [2601:8:b201:2c26::2b1]
 by dancol.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.84) (envelope-from <dancol@HIDDEN>)
 id 1Ywz3c-0003N7-5F; Mon, 25 May 2015 13:33:08 -0700
Message-ID: <55638701.9010400@HIDDEN>
Date: Mon, 25 May 2015 13:33:05 -0700
From: Daniel Colascione <dancol@HIDDEN>
User-Agent: Mozilla/5.0 (X11; Linux x86_64;
 rv:31.0) Gecko/20100101 Thunderbird/31.7.0
MIME-Version: 1.0
To: Stefan Monnier <monnier@HIDDEN>, 
 Philipp Stephani <p.stephani2@HIDDEN>
Subject: Re: bug#20640: 24.5;
 lexical-binding should work like a normal file-local variable
References: <m2a8wu5lc9.fsf@HIDDEN>
 <jwvr3q5to61.fsf-monnier+emacsbugs@HIDDEN>
In-Reply-To: <jwvr3q5to61.fsf-monnier+emacsbugs@HIDDEN>
Content-Type: multipart/signed; micalg=pgp-sha256;
 protocol="application/pgp-signature";
 boundary="HG1Ujj4vvR0mB43gt3lppHpfjwjd8l5uC"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 20640
Cc: 20640 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

This is an OpenPGP/MIME signed message (RFC 4880 and 3156)
--HG1Ujj4vvR0mB43gt3lppHpfjwjd8l5uC
Content-Type: text/plain; charset=windows-1252
Content-Transfer-Encoding: quoted-printable

On 05/24/2015 06:59 PM, Stefan Monnier wrote:
>> I think the only reason for this is an implementation detail
>> (lexical-binding is parsed by other code than the other file-local
>> variables).  It would be great to make it consistent with other
>> variables so that the user doesn't need to care about the difference.
>=20
> Allowing it at the end of the file, would require jumping to the end of=

> the file first, and then starting over from the beginning.
> That'd be a very bad requirement.

Why? We're going to have to read that page eventually anyway.


--HG1Ujj4vvR0mB43gt3lppHpfjwjd8l5uC
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: OpenPGP digital signature
Content-Disposition: attachment; filename="signature.asc"

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1

iQIcBAEBCAAGBQJVY4cCAAoJEN4WImmbpWBlG70P/1S0Jmxpgfaeu4hGUvMhF0ZC
zwEMN8ft3QBeZScqe55TwCqbzKQzklvopKEePT9/tvJZlFDbQiuSwsR4YLdTAXmN
RTC/fO73cjP9N1QHqEvvVhhLhBV7HBDeAuhgasyy43yw5C9S0z9xvXP205Xt8vpr
uH/ZCCzM0jLQDwLDM90h+dZnf21WGeV0kG0r0zCBFbL4iGLURjdRHscZCrOjTppc
6eEUcxy0XtTL790c19hYdvcH7KCm4N1eMFkKCeRIDa2zOWPJLxknN7XDqTqGbnAM
EQRwbE7K1PICqrZlc9EkkG7bMBifIttgBavr377oRWMy70rnLpBKXGJjTG8sNCb9
nJdJbV33F5aaZW8HFCRL4/TQNRXEx9aJ2ze7ItYOW49HSb5xn51tyO+CL0vBKYQw
n+714PIurOBx5W059wQlNnciKeRXSJH8ZaIH0+zrB+iO35EahXrMiBK+xuzNfEtI
7hmGuBwljf/j3wlW/GysO7pSTBbj6jLMns/1HBYPMbTePmKya2oZSWew8Sfu1lmy
JLphrVdOcRBTLeYvzznIJb4NQm+sDPajNBiJfRQx5wWNLp91UdqLtypy5yHJkfup
e8abcE7neNmWjks19vbyQZFCBhpkWe5K0JeA1XR0QSbY3C0tCXlkKS7oVkUDIfMB
WC/G8vYH9rQ27c44olMB
=ln6U
-----END PGP SIGNATURE-----

--HG1Ujj4vvR0mB43gt3lppHpfjwjd8l5uC--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#20640; Package emacs. Full text available.

Message received at 20640 <at> debbugs.gnu.org:


Received: (at 20640) by debbugs.gnu.org; 25 May 2015 02:00:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 24 22:00:05 2015
Received: from localhost ([127.0.0.1]:55088 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1YwhgN-0006Yc-KQ
	for submit <at> debbugs.gnu.org; Sun, 24 May 2015 22:00:04 -0400
Received: from ironport2-out.teksavvy.com ([206.248.154.181]:43793)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <monnier@HIDDEN>) id 1YwhgG-0006YK-OO
 for 20640 <at> debbugs.gnu.org; Sun, 24 May 2015 21:59:57 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: A0AyFgA731xV/9N+3mhcgxCEAoVVu0CHSwQCAoE8OxIBAQEBAQEBgQpBBYNdAQEDAVYjBQsLDiYSFBgNJIg3CM8jAQEBAQYBAQEBHos6hQUHhC0BBLUEI4I7gVkigngBAQE
X-IPAS-Result: A0AyFgA731xV/9N+3mhcgxCEAoVVu0CHSwQCAoE8OxIBAQEBAQEBgQpBBYNdAQEDAVYjBQsLDiYSFBgNJIg3CM8jAQEBAQYBAQEBHos6hQUHhC0BBLUEI4I7gVkigngBAQE
X-IronPort-AV: E=Sophos;i="5.13,465,1427774400"; d="scan'208";a="122057427"
Received: from 104-222-126-211.cpe.teksavvy.com (HELO fmsmemgm.homelinux.net)
 ([104.222.126.211])
 by ironport2-out.teksavvy.com with ESMTP/TLS/DHE-RSA-AES256-SHA;
 24 May 2015 21:59:47 -0400
Received: by fmsmemgm.homelinux.net (Postfix, from userid 20848)
 id BDFDEAE058; Sun, 24 May 2015 21:59:45 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Philipp Stephani <p.stephani2@HIDDEN>
Subject: Re: bug#20640: 24.5;
 lexical-binding should work like a normal file-local variable
Message-ID: <jwvr3q5to61.fsf-monnier+emacsbugs@HIDDEN>
References: <m2a8wu5lc9.fsf@HIDDEN>
Date: Sun, 24 May 2015 21:59:45 -0400
In-Reply-To: <m2a8wu5lc9.fsf@HIDDEN> (Philipp Stephani's message of "Sun,
 24 May 2015 12:19:34 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 20640
Cc: 20640 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

> I think the only reason for this is an implementation detail
> (lexical-binding is parsed by other code than the other file-local
> variables).  It would be great to make it consistent with other
> variables so that the user doesn't need to care about the difference.

Allowing it at the end of the file, would require jumping to the end of
the file first, and then starting over from the beginning.
That'd be a very bad requirement.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#20640; Package emacs. Full text available.
Forcibly Merged 10605 15849 20640. Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 24 May 2015 10:20:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 24 06:20:02 2015
Received: from localhost ([127.0.0.1]:54255 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1YwT0f-0008VX-Vm
	for submit <at> debbugs.gnu.org; Sun, 24 May 2015 06:20:02 -0400
Received: from eggs.gnu.org ([208.118.235.92]:38299)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <p.stephani2@HIDDEN>) id 1YwT0a-0008VF-HS
 for submit <at> debbugs.gnu.org; Sun, 24 May 2015 06:19:56 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1YwT0U-0006Wf-Bs
 for submit <at> debbugs.gnu.org; Sun, 24 May 2015 06:19:47 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: *
X-Spam-Status: No, score=1.1 required=5.0 tests=BAYES_50,
 FREEMAIL_ENVFROM_END_DIGIT,FREEMAIL_FROM,T_DKIM_INVALID autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:57748)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1YwT0U-0006WX-8i
 for submit <at> debbugs.gnu.org; Sun, 24 May 2015 06:19:46 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:51784)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1YwT0T-0001pf-5K
 for bug-gnu-emacs@HIDDEN; Sun, 24 May 2015 06:19:46 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1YwT0S-0006Vq-35
 for bug-gnu-emacs@HIDDEN; Sun, 24 May 2015 06:19:45 -0400
Received: from mail-wi0-x230.google.com ([2a00:1450:400c:c05::230]:38067)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1YwT0R-0006Vi-SM
 for bug-gnu-emacs@HIDDEN; Sun, 24 May 2015 06:19:44 -0400
Received: by wichy4 with SMTP id hy4so25135938wic.1
 for <bug-gnu-emacs@HIDDEN>; Sun, 24 May 2015 03:19:43 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=from:to:subject:date:message-id:mime-version:content-type;
 bh=2ahYAHkqtLLu1mfhusesHLzgYSAwPJsSiI/QrRGWAV8=;
 b=mJrmrJmdI01h/Eaa8qSeVooz0agU0gUC3CL2/4FEQ1Nxp8ZVKBoobJNCT0cdB13N1P
 pL7XXPAtdFZ/hB0EzfpBdZb2K/KrIt0tEW1zkjZjZmzA6wE5QiTgQ5G03diCUOVTSX1j
 mlzY98YahzipMNGUbwSDc5f/CR5Wab8V+qgl2Au28OWAFJ/tgdqK6Z8QpD0ikQGfjON4
 fHFajM5pkfrcSBDj793l3nfu/mIT6eaMYdZQu+YdgtuoBVZ9Ddg+2PE7KnGvjosCqdc9
 dmrpllhQTWqIa5yNP0YTcYYlGPFUCmAb7BLPW6lFH1CASX3usob5PmYthXeKDwGFiASe
 UgYQ==
X-Received: by 10.194.63.80 with SMTP id e16mr30918070wjs.56.1432462782996;
 Sun, 24 May 2015 03:19:42 -0700 (PDT)
Received: from p ([2001:4c50:32e:4e00:40e4:3b61:5b96:f7b4])
 by mx.google.com with ESMTPSA id ex5sm6643088wib.2.2015.05.24.03.19.42
 for <bug-gnu-emacs@HIDDEN>
 (version=TLSv1.2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Sun, 24 May 2015 03:19:42 -0700 (PDT)
From: Philipp Stephani <p.stephani2@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 24.5; lexical-binding should work like a normal file-local variable
Date: Sun, 24 May 2015 12:19:34 +0200
Message-ID: <m2a8wu5lc9.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -3.8 (---)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.8 (---)


The manual
(https://www.gnu.org/software/emacs/manual/html_node/elisp/Using-Lexical-Binding.html)
says about `lexical-binding':

   Note that unlike other such variables, this one must be set in the
   first line of a file.

I think the only reason for this is an implementation detail
(lexical-binding is parsed by other code than the other file-local
variables).  It would be great to make it consistent with other
variables so that the user doesn't need to care about the difference.



In GNU Emacs 24.5.1 (x86_64-apple-darwin14.1.0, NS apple-appkit-1344.72)
 of 2015-04-12 on p
Configured using:
 `configure --prefix=/usr/local/Cellar/emacs/24.5
 --enable-locallisppath=/usr/local/share/emacs/site-lisp
 --infodir=/usr/local/Cellar/emacs/24.5/share/info/emacs
 --with-file-notification=gfile --with-dbus --with-gnutls --with-rsvg
 --with-imagemagick --without-popmail --with-ns
 --disable-ns-self-contained'

Important settings:
  value of $LANG: de_DE.UTF-8
  locale-coding-system: utf-8-unix

Major mode: Emacs-Lisp

Minor modes in effect:
  tooltip-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Recent messages:
For information about GNU Emacs and the GNU system, type C-h C-a.
(New file)
For this change to take effect revisit file using s-u
Saving file /tmp/foo.el...
Wrote /tmp/foo.el
C-x C-g is undefined
You can run the command `revert-buffer' with s-u

Load-path shadows:
None found.

Features:
(shadow sort gnus-util mail-extr emacsbug message format-spec rfc822 mml
easymenu mml-sec mm-decode mm-bodies mm-encode mail-parse rfc2231
mailabbrev gmm-utils mailheader sendmail rfc2047 rfc2045 ietf-drums
mm-util mail-prsvr mail-utils warnings help-fns files-x xterm time-date
tooltip electric uniquify ediff-hook vc-hooks lisp-float-type mwheel
ns-win tool-bar dnd fontset image regexp-opt fringe tabulated-list
newcomment lisp-mode prog-mode register page menu-bar rfn-eshadow timer
select scroll-bar mouse jit-lock font-lock syntax facemenu font-core
frame cham georgian utf-8-lang misc-lang vietnamese tibetan thai
tai-viet lao korean japanese hebrew greek romanian slovak czech european
ethiopic indian cyrillic chinese case-table epa-hook jka-cmpr-hook help
simple abbrev minibuffer nadvice loaddefs button faces cus-face macroexp
files text-properties overlay sha1 md5 base64 format env code-pages mule
custom widget hashtable-print-readable backquote make-network-process
dbusbind gfilenotify cocoa ns multi-tty emacs)

Memory information:
((conses 16 79278 6322)
 (symbols 48 17661 0)
 (miscs 40 38 142)
 (strings 32 10374 4568)
 (string-bytes 1 270725)
 (vectors 16 7214)
 (vector-slots 8 341033 28254)
 (floats 8 62 328)
 (intervals 56 188 27)
 (buffers 960 14))




Acknowledgement sent to Philipp Stephani <p.stephani2@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#20640; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 22 Jun 2015 16:00:06 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.